Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.management.timer
Class Timer

    java.lang.Object
      |
      +--javax.management.NotificationBroadcasterSupport
            |
            +--javax.management.timer.Timer

All Implemented Interfaces:
  MBeanRegistration, NotificationBroadcaster, NotificationEmitter, TimerMBean

public class Timer
extends NotificationBroadcasterSupport
implements TimerMBean, MBeanRegistration

Provides the implementation of the timer MBean. The timer MBean sends out an alarm at a specified time that wakes up all the listeners registered to receive timer notifications.

This class manages a list of dated timer notifications. A method allows users to add/remove as many notifications as required. When a timer notification is emitted by the timer and becomes obsolete, it is automatically removed from the list of timer notifications.
Additional timer notifications can be added into regularly repeating notifications.

Note:

1. All notifications before the time when the `addNotification` method is called are ignored, irrespective of the `sendPastNotifications` flag.
2. When sending timer notifications, the timer updates the notification sequence number irrespective of the notification type.
3. The timer service relies on the system date of the host where the `Timer` class is loaded. Listeners may receive untimely notifications if their host has a different system date. To avoid such problems, synchronize the system date of all host machines where timing is needed.
4. The default behaviour for periodic notifications is fixed-delay execution, as specified in `Timer`. In order to use fixed-rate execution, use the overloaded `addNotification(String, String, Object, Date, long, long, boolean)` method.
5. Notification listeners are potentially all executed in the same thread. Therefore, they should execute rapidly to avoid holding up other listeners or perturbing the regularity of fixed-delay executions. See `NotificationBroadcasterSupport`.

Author:
  Young Yang

Constructor Summary
`Timer()`

Method Summary
`java.lang.Integer` | `addNotification(java.lang.String type, java.lang.String message, java.lang.Object userData, java.util.Date date)` Creates a new timer notification with the specified `type`, `message` and `userData` and inserts it into the list of notifications with a given date and a null period and number of occurences.
`java.lang.Integer` | `addNotification(java.lang.String type, java.lang.String message, java.lang.Object userData, java.util.Date date, long period)` Creates a new timer notification with the specified `type`, `message` and `userData` and inserts it into the list of notifications with a given date and period and a null number of occurences.
`java.lang.Integer` | `addNotification(java.lang.String type, java.lang.String message, java.lang.Object userData, java.util.Date date, long period, long nbOccurences)` add a notification to the Timer
`java.lang.Integer` | `addNotification(java.lang.String type, java.lang.String message, java.lang.Object userData, java.util.Date date, long period, long nbOccurences, boolean fixedRate)` Creates a new timer notification with the specified `type`, `message` and `userData` and inserts it into the list of notifications with a given date, period and number of occurences.
`java.util.Vector` | `getAllNotificationIDs()` Gets all timer notification identifiers registered into the list of notifications.
`java.util.Date` | `getDate(java.lang.Integer id)` Gets a copy of the date associated to a timer notification.
`java.lang.Boolean` | `getFixedRate(java.lang.Integer id)` Gets a copy of the flag indicating whether a peridic notification is executed at fixed-delay or at fixed-rate.
`int` | `getNbNotifications()` Gets the number of timer notifications registered into the list of notifications.
`java.lang.Long` | `getNbOccurences(java.lang.Integer id)` Gets a copy of the remaining number of occurences associated to a timer notification.
`java.util.Vector` | `getNotificationIDs(java.lang.String type)` Gets all the identifiers of timer notifications corresponding to the specified type.
`MBeanNotificationInfo[]` | `getNotificationInfo()` Returns a NotificationInfo object contaning the name of the Java class of the notification and the notification types sent.
`java.lang.String` | `getNotificationMessage(java.lang.Integer id)` Gets the timer notification detailed message corresponding to the specified identifier.
`java.lang.String` | `getNotificationType(java.lang.Integer id)` Gets the timer notification type corresponding to the specified identifier.
`java.lang.Object` | `getNotificationUserData(java.lang.Integer id)` Gets the timer notification user data object corresponding to the specified identifier.
`java.lang.Long` | `getPeriod(java.lang.Integer id)` Gets a copy of the period (in milliseconds) associated to a timer notification.
`boolean` | `getSendPastNotifications()` Gets the flag indicating whether or not the timer sends past notifications.
`boolean` | `isActive()` Tests whether the timer MBean is active.
`boolean` | `isEmpty()` Tests whether the list of timer notifications is empty.
`void` | `postDeregister()` Allows the MBean to perform any operations needed after having been de-registered in the MBean server.
`void` | `postRegister(java.lang.Boolean boolean1)` Allows the MBean to perform any operations needed after having been registered in the MBean server or after the registration has failed.
`void` | `preDeregister()` Allows the MBean to perform any operations it needs before being de-registered by the MBean server.
`ObjectName` | `preRegister(MBeanServer mbeanserver, ObjectName objectname)` Allows the MBean to perform any operations it needs before being registered in the MBean server.
`void` | `removeAllNotifications()` Removes all the timer notifications from the list of notifications and resets the counter used to update the timer notification identifiers.
`void` | `removeNotification(java.lang.Integer id)` Removes the timer notification corresponding to the specified identifier from the list of notifications.
`void` | `removeNotifications(java.lang.String type)` Removes all the timer notifications corresponding to the specified type from the list of notifications.
`void` | `setSendPastNotifications(boolean flag)` Sets the flag indicating whether the timer sends past notifications or not.
`void` | `start()` Starts the timer.
`void` | `stop()` Stops the timer.

Methods inherited from class javax.management.NotificationBroadcasterSupport
`addNotificationListener, handleNotification, removeNotificationListener, removeNotificationListener, sendNotification`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Timer

    public Timer()

Method Detail

### preRegister

    public ObjectName preRegister(MBeanServer mbeanserver,
                                  ObjectName objectname)
                           throws java.lang.Exception

  Description copied from interface: `MBeanRegistration`
  Allows the MBean to perform any operations it needs before being registered in the MBean server. If the name of the MBean is not specified, the MBean can provide a name for its registration. If any exception is raised, the MBean will not be registered in the MBean server.
  Specified by:
    `preRegister` in interface `MBeanRegistration`
  Following copied from interface: `javax.management.MBeanRegistration`
  Parameters:
    `server` - The MBean server in which the MBean will be registered.
    `name` - The object name of the MBean.
  Returns:
    The name of the MBean registered.
  Throws:
    `java.lang.Exception` - This exception should be caught by the MBean server and re-thrown as an `MBeanRegistrationException`.

### postRegister

    public void postRegister(java.lang.Boolean boolean1)

  Description copied from interface: `MBeanRegistration`
  Allows the MBean to perform any operations needed after having been registered in the MBean server or after the registration has failed.
  Specified by:
    `postRegister` in interface `MBeanRegistration`
  Following copied from interface: `javax.management.MBeanRegistration`
  Parameters:
    `registrationDone` - Indicates whether or not the MBean has been successfully registered in the MBean server. The value false means that the registration phase has failed.

### preDeregister

    public void preDeregister()
                       throws java.lang.Exception

  Description copied from interface: `MBeanRegistration`
  Allows the MBean to perform any operations it needs before being de-registered by the MBean server.
  Specified by:
    `preDeregister` in interface `MBeanRegistration`
  Following copied from interface: `javax.management.MBeanRegistration`
  Throws:
    `java.lang.Exception` - This exception should be caught by the MBean server and re-thrown as an `MBeanRegistrationException`.

### postDeregister

    public void postDeregister()

  Description copied from interface: `MBeanRegistration`
  Allows the MBean to perform any operations needed after having been de-registered in the MBean server.
  Specified by:
    `postDeregister` in interface `MBeanRegistration`

### start

    public void start()

  Description copied from interface: `TimerMBean`
  Starts the timer.

  If there is one or more timer notifications before the time in the list of notifications, the notification is sent according to the `sendPastNotifications` flag and then, updated according to its period and remaining number of occurences. If the timer notification date remains earlier than the current date, this notification is just removed from the list of notifications.

  Specified by:
    `start` in interface `TimerMBean`

### stop

    public void stop()

  Description copied from interface: `TimerMBean`
  Stops the timer.
  Specified by:
    `stop` in interface `TimerMBean`

### addNotification

    public java.lang.Integer addNotification(java.lang.String type,
                                             java.lang.String message,
                                             java.lang.Object userData,
                                             java.util.Date date,
                                             long period,
                                             long nbOccurences)
                                      throws java.lang.IllegalArgumentException

  add a notification to the Timer
  Specified by:
    `addNotification` in interface `TimerMBean`
  Parameters:
    `type` - The notification type string.
    `message` - The notification¡¯s detailed message string.
    `userData` - The notification¡¯s user data object.
    `date` - The date when the notification will occur. The Timer class includes integer constants for expressing durations in milliseconds, which can then be used to doCreate java.util.Date objects.
    `period` - The interval in milliseconds between notification occurrences. Repeating notifications are not enabled if this parameter is zero or null.
    `nbOccurences` - The total number of times that the notification will occur. If the value of this parameter is zero or is not defined (null), and if the period is not zero or null, then the notification will repeat indefinitely.
  Returns:
  Throws:
    `java.lang.IllegalArgumentException` -

### addNotification

    public java.lang.Integer addNotification(java.lang.String type,
                                             java.lang.String message,
                                             java.lang.Object userData,
                                             java.util.Date date,
                                             long period)
                                      throws java.lang.IllegalArgumentException

  Description copied from interface: `TimerMBean`
  Creates a new timer notification with the specified `type`, `message` and `userData` and inserts it into the list of notifications with a given date and period and a null number of occurences.

  The timer notification will repeat continuously using the timer period using a fixed-delay execution scheme, as specified in `Timer`. In order to use a fixed-rate execution scheme, use `TimerMBean.addNotification(String, String, Object, Date, long, long, boolean)` instead.

  If the timer notification to be inserted has a date that is before the current date, the method behaves as if the specified date were the current date. The first notification is delivered immediately and the subsequent ones are spaced as specified by the period parameter.

  Specified by:
    `addNotification` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Parameters:
    `type` - The timer notification type.
    `message` - The timer notification detailed message.
    `userData` - The timer notification user data object.
    `date` - The date when the notification occurs.
    `period` - The period of the timer notification (in milliseconds).
  Returns:
    The identifier of the new created timer notification.
  Throws:
    `java.lang.IllegalArgumentException` - The period is negative or the date notification is before the current date.

### addNotification

    public java.lang.Integer addNotification(java.lang.String type,
                                             java.lang.String message,
                                             java.lang.Object userData,
                                             java.util.Date date)
                                      throws java.lang.IllegalArgumentException

  Description copied from interface: `TimerMBean`
  Creates a new timer notification with the specified `type`, `message` and `userData` and inserts it into the list of notifications with a given date and a null period and number of occurences.

  The timer notification will be handled once at the specified date.

  If the timer notification to be inserted has a date that is before the current date, the method behaves as if the specified date were the current date and the notification is delivered immediately.

  Specified by:
    `addNotification` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Parameters:
    `type` - The timer notification type.
    `message` - The timer notification detailed message.
    `userData` - The timer notification user data object.
    `date` - The date when the notification occurs.
  Returns:
    The identifier of the new created timer notification.
  Throws:
    `java.lang.IllegalArgumentException` - The date notification is before the current date.

### addNotification

    public java.lang.Integer addNotification(java.lang.String type,
                                             java.lang.String message,
                                             java.lang.Object userData,
                                             java.util.Date date,
                                             long period,
                                             long nbOccurences,
                                             boolean fixedRate)
                                      throws java.lang.IllegalArgumentException

  Description copied from interface: `TimerMBean`
  Creates a new timer notification with the specified `type`, `message` and `userData` and inserts it into the list of notifications with a given date, period and number of occurences.

  If the timer notification to be inserted has a date that is before the current date, the method behaves as if the specified date were the current date.
  For once-off notifications, the notification is delivered immediately.
  For periodic notifications, the first notification is delivered immediately and the subsequent ones are spaced as specified by the period parameter.

  Note that once the timer notification has been added into the list of notifications, its associated date, period and number of occurences cannot be updated.

  In the case of a periodic notification, the value of parameter fixedRate is used to specify the execution scheme, as specified in `Timer`.

  Specified by:
    `addNotification` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Parameters:
    `type` - The timer notification type.
    `message` - The timer notification detailed message.
    `userData` - The timer notification user data object.
    `date` - The date when the notification occurs.
    `period` - The period of the timer notification (in milliseconds).
    `nbOccurences` - The total number the timer notification will be emitted.
    `fixedRate` - If `true` and if the notification is periodic, the notification is scheduled with a fixed-rate execution scheme. If `false` and if the notification is periodic, the notification is scheduled with a fixed-delay execution scheme. Ignored if the notification is not periodic.
  Returns:
    The identifier of the new created timer notification.
  Throws:
    `java.lang.IllegalArgumentException` - The period or the number of occurences is negative
  See Also:
    `TimerMBean.addNotification(String, String, Object, Date, long, long)`

### removeNotification

    public void removeNotification(java.lang.Integer id)
                            throws InstanceNotFoundException

  Description copied from interface: `TimerMBean`
  Removes the timer notification corresponding to the specified identifier from the list of notifications.
  Specified by:
    `removeNotification` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Parameters:
    `id` - The timer notification identifier.
  Throws:
    `InstanceNotFoundException` - The specified identifier does not correspond to any timer notification in the list of notifications of this timer MBean.

### removeNotifications

    public void removeNotifications(java.lang.String type)
                             throws InstanceNotFoundException

  Description copied from interface: `TimerMBean`
  Removes all the timer notifications corresponding to the specified type from the list of notifications.
  Specified by:
    `removeNotifications` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Parameters:
    `type` - The timer notification type.
  Throws:
    `InstanceNotFoundException` - The specified type does not correspond to any timer notification in the list of notifications of this timer MBean.

### removeAllNotifications

    public void removeAllNotifications()

  Description copied from interface: `TimerMBean`
  Removes all the timer notifications from the list of notifications and resets the counter used to update the timer notification identifiers.
  Specified by:
    `removeAllNotifications` in interface `TimerMBean`

### getNbNotifications

    public int getNbNotifications()

  Description copied from interface: `TimerMBean`
  Gets the number of timer notifications registered into the list of notifications.
  Specified by:
    `getNbNotifications` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Returns:
    The number of timer notifications.

### getAllNotificationIDs

    public java.util.Vector getAllNotificationIDs()

  Description copied from interface: `TimerMBean`
  Gets all timer notification identifiers registered into the list of notifications.
  Specified by:
    `getAllNotificationIDs` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Returns:
    A vector of `Integer` objects containing all the timer notification identifiers.
    The vector is empty if there is no timer notification registered for this timer MBean.

### getNotificationIDs

    public java.util.Vector getNotificationIDs(java.lang.String type)

  Description copied from interface: `TimerMBean`
  Gets all the identifiers of timer notifications corresponding to the specified type.
  Specified by:
    `getNotificationIDs` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Parameters:
    `type` - The timer notification type.
  Returns:
    A vector of `Integer` objects containing all the identifiers of timer notifications with the specified `type`.
    The vector is empty if there is no timer notifications registered for this timer MBean with the specified `type`.

### getNotificationType

    public java.lang.String getNotificationType(java.lang.Integer id)

  Description copied from interface: `TimerMBean`
  Gets the timer notification type corresponding to the specified identifier.
  Specified by:
    `getNotificationType` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Parameters:
    `id` - The timer notification identifier.
  Returns:
    The timer notification type or null if the identifier is not mapped to any timer notification registered for this timer MBean.

### getNotificationMessage

    public java.lang.String getNotificationMessage(java.lang.Integer id)

  Description copied from interface: `TimerMBean`
  Gets the timer notification detailed message corresponding to the specified identifier.
  Specified by:
    `getNotificationMessage` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Parameters:
    `id` - The timer notification identifier.
  Returns:
    The timer notification detailed message or null if the identifier is not mapped to any timer notification registered for this timer MBean.

### getNotificationUserData

    public java.lang.Object getNotificationUserData(java.lang.Integer id)

  Description copied from interface: `TimerMBean`
  Gets the timer notification user data object corresponding to the specified identifier.
  Specified by:
    `getNotificationUserData` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Parameters:
    `id` - The timer notification identifier.
  Returns:
    The timer notification user data object or null if the identifier is not mapped to any timer notification registered for this timer MBean.

### getDate

    public java.util.Date getDate(java.lang.Integer id)

  Description copied from interface: `TimerMBean`
  Gets a copy of the date associated to a timer notification.
  Specified by:
    `getDate` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Parameters:
    `id` - The timer notification identifier.
  Returns:
    A copy of the date or null if the identifier is not mapped to any timer notification registered for this timer MBean.

### getPeriod

    public java.lang.Long getPeriod(java.lang.Integer id)

  Description copied from interface: `TimerMBean`
  Gets a copy of the period (in milliseconds) associated to a timer notification.
  Specified by:
    `getPeriod` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Parameters:
    `id` - The timer notification identifier.
  Returns:
    A copy of the period or null if the identifier is not mapped to any timer notification registered for this timer MBean.

### getNbOccurences

    public java.lang.Long getNbOccurences(java.lang.Integer id)

  Description copied from interface: `TimerMBean`
  Gets a copy of the remaining number of occurences associated to a timer notification.
  Specified by:
    `getNbOccurences` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Parameters:
    `id` - The timer notification identifier.
  Returns:
    A copy of the remaining number of occurences or null if the identifier is not mapped to any timer notification registered for this timer MBean.

### getFixedRate

    public java.lang.Boolean getFixedRate(java.lang.Integer id)

  Description copied from interface: `TimerMBean`
  Gets a copy of the flag indicating whether a peridic notification is executed at fixed-delay or at fixed-rate.
  Specified by:
    `getFixedRate` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Parameters:
    `id` - The timer notification identifier.
  Returns:
    A copy of the flag indicating whether a peridic notification is executed at fixed-delay or at fixed-rate.

### getSendPastNotifications

    public boolean getSendPastNotifications()

  Description copied from interface: `TimerMBean`
  Gets the flag indicating whether or not the timer sends past notifications.
  Specified by:
    `getSendPastNotifications` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Returns:
    The past notifications sending on/off flag value.
  See Also:
    `TimerMBean.setSendPastNotifications(boolean)`

### setSendPastNotifications

    public void setSendPastNotifications(boolean flag)

  Description copied from interface: `TimerMBean`
  Sets the flag indicating whether the timer sends past notifications or not.
  Specified by:
    `setSendPastNotifications` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Parameters:
    `value` - The past notifications sending on/off flag value.
  See Also:
    `TimerMBean.getSendPastNotifications()`

### isActive

    public boolean isActive()

  Description copied from interface: `TimerMBean`
  Tests whether the timer MBean is active. A timer MBean is marked active when the `doStart` method is called. It becomes inactive when the `doStop` method is called.
  Specified by:
    `isActive` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Returns:
    `true` if the timer MBean is active, `false` otherwise.

### isEmpty

    public boolean isEmpty()

  Description copied from interface: `TimerMBean`
  Tests whether the list of timer notifications is empty.
  Specified by:
    `isEmpty` in interface `TimerMBean`
  Following copied from interface: `javax.management.timer.TimerMBean`
  Returns:
    `true` if the list of timer notifications is empty, `false` otherwise.

### getNotificationInfo

    public MBeanNotificationInfo[] getNotificationInfo()

  Description copied from class: `NotificationBroadcasterSupport`
  Returns a NotificationInfo object contaning the name of the Java class of the notification and the notification types sent.
  Overrides:
    `getNotificationInfo` in class `NotificationBroadcasterSupport`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD